local type, next, math, table, tableContainsCaseInsensitive = type, next, math, table, tableContainsCaseInsensitive

local VEHICLE_TYPE_BLACKLIST = {
	"Debug",
	"Prop",
	"PropParked",
	"PropTraffic",
	"Traffic",
	"Trailer"
}

local configList = nil

local function getRandomConfig()
	if not configList then configList = core_vehicles.getConfigList(true).configs end

	while #configList ~= 0 do
		local randomIndex = math.random(#configList)
		local randomConfig = configList[randomIndex]
		if type(randomConfig) == "table" and
		   type(randomConfig.model_key) == "string" and
		   type(randomConfig.key) == "string" and
		   type(randomConfig.aggregates) == "table" and
		   type(randomConfig.aggregates.Type) == "table" and
		   type(next(randomConfig.aggregates.Type)) == "string" and
		   not tableContainsCaseInsensitive(VEHICLE_TYPE_BLACKLIST, next(randomConfig.aggregates.Type)) then
				return randomConfig
		end

		table.remove(configList, randomIndex)
	end
end

return getRandomConfig